/**
 * <copyright>
 * </copyright>
 *
 * $Id: ValueModelType.java 8328 2011-08-29 13:37:02Z mjohannes $
 */
package org.openxma.dsl.core.model;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

import org.eclipse.emf.common.util.Enumerator;

/**
 * <!-- begin-user-doc -->
 * A representation of the literals of the enumeration '<em><b>Value Model Type</b></em>',
 * and utility methods for working with them.
 * <!-- end-user-doc -->
 * @see org.openxma.dsl.core.CorePackage#getValueModelType()
 * @model
 * @generated
 */
public enum ValueModelType implements Enumerator {
	/**
     * The '<em><b>NULL</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #NULL_VALUE
     * @generated
     * @ordered
     */
	NULL(0, "NULL", "NULL"), /**
     * The '<em><b>String</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #STRING_VALUE
     * @generated
     * @ordered
     */
	STRING(1, "string", "string"),

	/**
     * The '<em><b>Number</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #NUMBER_VALUE
     * @generated
     * @ordered
     */
	NUMBER(2, "number", "number"),

	/**
     * The '<em><b>Boolean</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #BOOLEAN_VALUE
     * @generated
     * @ordered
     */
	BOOLEAN(3, "boolean", "boolean"),

	/**
     * The '<em><b>Date</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #DATE_VALUE
     * @generated
     * @ordered
     */
	DATE(4, "date", "date"),

	/**
     * The '<em><b>Timestamp</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #TIMESTAMP_VALUE
     * @generated
     * @ordered
     */
	TIMESTAMP(5, "timestamp", "timestamp"),

	/**
     * The '<em><b>Enumeration</b></em>' literal object.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @see #ENUMERATION_VALUE
     * @generated
     * @ordered
     */
	ENUMERATION(6, "enumeration", "enumeration");

	/**
     * The '<em><b>NULL</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>NULL</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #NULL
     * @model
     * @generated
     * @ordered
     */
	public static final int NULL_VALUE = 0;

	/**
     * The '<em><b>String</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>String</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #STRING
     * @model name="string"
     * @generated
     * @ordered
     */
	public static final int STRING_VALUE = 1;

	/**
     * The '<em><b>Number</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Number</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #NUMBER
     * @model name="number"
     * @generated
     * @ordered
     */
	public static final int NUMBER_VALUE = 2;

	/**
     * The '<em><b>Boolean</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Boolean</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #BOOLEAN
     * @model name="boolean"
     * @generated
     * @ordered
     */
	public static final int BOOLEAN_VALUE = 3;

	/**
     * The '<em><b>Date</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Date</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #DATE
     * @model name="date"
     * @generated
     * @ordered
     */
	public static final int DATE_VALUE = 4;

	/**
     * The '<em><b>Timestamp</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Timestamp</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #TIMESTAMP
     * @model name="timestamp"
     * @generated
     * @ordered
     */
	public static final int TIMESTAMP_VALUE = 5;

	/**
     * The '<em><b>Enumeration</b></em>' literal value.
     * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of '<em><b>Enumeration</b></em>' literal object isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
     * @see #ENUMERATION
     * @model name="enumeration"
     * @generated
     * @ordered
     */
	public static final int ENUMERATION_VALUE = 6;

	/**
     * An array of all the '<em><b>Value Model Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private static final ValueModelType[] VALUES_ARRAY =
		new ValueModelType[] {
            NULL,
            STRING,
            NUMBER,
            BOOLEAN,
            DATE,
            TIMESTAMP,
            ENUMERATION,
        };

	/**
     * A public read-only list of all the '<em><b>Value Model Type</b></em>' enumerators.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static final List<ValueModelType> VALUES = Collections.unmodifiableList(Arrays.asList(VALUES_ARRAY));

	/**
     * Returns the '<em><b>Value Model Type</b></em>' literal with the specified literal value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ValueModelType get(String literal) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            ValueModelType result = VALUES_ARRAY[i];
            if (result.toString().equals(literal)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Value Model Type</b></em>' literal with the specified name.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ValueModelType getByName(String name) {
        for (int i = 0; i < VALUES_ARRAY.length; ++i) {
            ValueModelType result = VALUES_ARRAY[i];
            if (result.getName().equals(name)) {
                return result;
            }
        }
        return null;
    }

	/**
     * Returns the '<em><b>Value Model Type</b></em>' literal with the specified integer value.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public static ValueModelType get(int value) {
        switch (value) {
            case NULL_VALUE: return NULL;
            case STRING_VALUE: return STRING;
            case NUMBER_VALUE: return NUMBER;
            case BOOLEAN_VALUE: return BOOLEAN;
            case DATE_VALUE: return DATE;
            case TIMESTAMP_VALUE: return TIMESTAMP;
            case ENUMERATION_VALUE: return ENUMERATION;
        }
        return null;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final int value;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String name;

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private final String literal;

	/**
     * Only this class can construct instances.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	private ValueModelType(int value, String name, String literal) {
        this.value = value;
        this.name = name;
        this.literal = literal;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public int getValue() {
      return value;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getName() {
      return name;
    }

	/**
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	public String getLiteral() {
      return literal;
    }

	/**
     * Returns the literal value of the enumerator, which is its string representation.
     * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
     * @generated
     */
	@Override
	public String toString() {
        return literal;
    }
	
} //ValueModelType
